{
    LanTsr 0.1   - A Remote-Control-Program for DOS-Systems
    Copyright (C) 1996, 1997, 1998 Daniel von Dincklage
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}
{$M 5000, 8000, 8000}
{ ************************************************************************** }
{ *** Final Version 1.0 / 25.10.1996 / Build 1932.5438-1                 *** }
{ ************************************************************************** }

{ Speichervernderungen :
  ALT : 10000, 16000, 16000
  ALT : 20000, 20000, 20000

 13.10.1996 : Version 1.1 des Treibers (Funktionalitt mit SwapDirName)

 Optimierungen :

  TIME       LINE      COMPTIME         SIZE             DATA
  17:33      1990      1,0              10016            760
  17:35      1979      0,7              9520   (-496)    760
  10:08      1802      0,7              9856             760
  10:10      1119      0,4              9856             760

 }

Uses Dos,Crt,NetTypes,NetBUnit;

{$I TYPECONS}
{$I NEBTSR}

Const
{ ************************************************************************** }
{ *** Wichtige Konstanten                                                *** }
{ ************************************************************************** }
                        VersionHi = 1;
                        VersionLo = 0;           { Die Version. }
          ManagerLoaded : Boolean = FALSE;       { Treiber-Manager geladen ? }


Var
                 DriverManager : CallProc;



Procedure InitManager; Assembler;
Asm
  Mov Ah, 0C5h                                   { C5h -> Mein Treiber ID fr das gesamte Verwaltungsteil }
  Mov Al, 0AAh                                   { AAh -> Install-Check }
  Mov Bx, 00h                                    { 00h -> Fr Manager (Hat ID = 0) }
  Int 2Fh
  Cmp Bx, 0FFh                                   { BX = FF -> Installiert. BX <> FF -> Nicht installiert }
  Jne @NichtInstalliert
  Mov Ah, 0C5h                                   { Wieder meine Treiber-Sammlung }
  Mov Al, CMD_GETPROCADDRESS                     { Ich will die Addresse der Treiber-Proc }
  Mov Bx, 0
  Int 2Fh
  Mov Word Ptr DriverManager, Ax                  { Y.Lo <- AX }
  Mov Word Ptr DriverManager + 2, Bx              { Y.HI <- BX }
  Mov ManagerLoaded, 1
  Jmp @ENDE
  @NichtInstalliert:
  Mov ManagerLoaded, 0
  @ENDE:
End;

Procedure RegisterDriver;
Var
 Structure : tRegisterDriver;
Begin
 With Structure do
  Begin
      DriverID := PROT_NetBIOS;
           Mtu := NetBIOS_MaximalPacketSize;
     NameShort := 'Neb';
      NameLong := ' NetBIOS  ';
      DataPart := NetBIOS_MaximalDataSize;
   CompareProc := CompareNetBIOSIDs;
      SendProc := SendNetBIOSPacket;
 InitalizeProc := InitializeNetBioS;
      KillProc := DeInitializeNetBIOS;
  ToCallProcPt := Addr(ProcToCall);
     NetAddrPt := @MyNetWorkID;
LongVersion.Lo := VersionLo;
LongVersion.Hi := VersionHI;
   DirNameAddr := @SwapDirName;
  End;
 DriverManager(DRVCMD_REGISTERDRIVER,@Structure);
End;

Procedure KillDriver;
Var
 Structure : tKillDriver;
Begin
 With Structure do
  Begin
    DRIVERID := PROT_NetBIOS;
  End;
 DriverManager(DRVCMD_DELETEDRIVER,@Structure);
End;


Var
 Lauf1 : Word;

Begin
 InitManager;

 If (TsrIsInst( I2F_CODE ) = FALSE) and ManagerLoaded then       { Ist das Programm bereits installiert ? }
  Begin                                          { Nein, das Programm resident installieren ! }
   Writeln( 'Der Protokoll-Treiber (NetBIOS) wurde erfolgreich installiert.' );
   { Den Speicher fr die ECBs etc. belegen }
   RegisterDriver;

   TsrInit(NIL,MemW[PrefixSeg:2]-PrefixSeg);{ das Programm mit den zu belegenden Paragraphen installieren }
  End
 else                                            { Programm war bereits installiert }
  Begin
   If ManagerLoaded = FALSE then
    Begin
     Writeln('Achtung ! Vor den Treibern muss der Treiber-Manager installiert werden ! ');
    End
   Else
    Begin
     If TsrCanUnInst then                        { Ist es mglich, das Programm zu deinstallieren ? }
      Begin                                      { JA ! }
       KillDriver;
       TsrSetPtr(ofs(EndePrz));                  { Ende-Prozedur in der bereits }
       Call.OAProz;                              { installierten Kopie aufrufen  }
       TsrUnInst;
       Writeln( 'Der Protokoll-Treiber (NetBIOS) wurde erfolgreich aus dem Speicher entfernt.');
      end
     else
      Begin                                      { Das Programm kann nicht deinstalliert werden, Nachricht ausgeben. }
       Writeln('Der Protokoll-Treiber (NetBIOS) konnte nicht deinstalliert werden.');
       Writeln('Sollten sie TSR-Programme nach diesem geladen haben, so entfernen');
       Writeln('sie diese zuerst.');
      End;
    End;
  End;
End.