{
    LanTsr 0.1   - A Remote-Control-Program for DOS-Systems
    Copyright (C) 1996, 1997, 1998 Daniel von Dincklage
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}
Function GetPaletteData( ProcessData : pVideoProcess; DataBuffer : pByte; Var WriteByte : Word ) : Word;
Const
   ATTR_CONTROL = $3C1;                         { Port fr Lesezugriffe auf den Attribute Controller }
Var
        Lauf1,Lauf2 : Word;

{ Die Daten werden immer in der Reihenfolge R-G-B bertragen !!! }
Begin
 With ProcessData^ do
  Begin
   Case VioMode of                     { Nach Farben aufteilen !}
    $03,$02,$12,$10,$0D,$0E : Begin { 16 Farben ! }
              If ReturnBytes < 16 then GetPaletteData := 0  { Fr 16 Bytes doch keinen grossen Terz machen .... }
               Else
                Begin
                 For Lauf1 := 0 to 15 do
                  Begin
                   DataBuffer^ := ReadAttributeReg(Lauf1);
                   Inc(DataBuffer);
                  End;
                GetPaletteData := 0;
                WriteByte := 16;
                TransMitted := 16;
               End;
             End;
       $13 : Begin { 256 Farben aus 3-Byte Palette }
              If ReturnBytes < 3 then GetPaletteData := 0;
              While ReturnBytes mod 3 <> 0 do Dec(ReturnBytes); { Es mssen immer komplette DAC-Register bertragen werden ! }
              { ^ Optimieren ! }
              Lauf1 := (Transmitted div 3) ;
              If (Transmitted + ReturnBytes) >= Palette_Transmit[VioMode] then
               Begin
                GetPaletteData := 0;
                WriteByte := (Palette_Transmit[VioMode] - Transmitted);
                Lauf2 := WriteByte div 3;
               End
              Else
               Begin
                Lauf2 := ReturnBytes div 3;
                GetPaletteData := ReturnBytes;
                WriteByte := ReturnBytes;
               End;

               Asm
                Mov Ax, $1017
                Mov Bx, Lauf1
                Mov Cx, Lauf2
                Les Dx, DataBuffer               { ES:DX -> Zeiger auf den Puffer }
                Int $10
               End;
              Inc(Transmitted, ReturnBytes);
             End;
        else
          begin { Ich komm mit dem Modus nicht klar, d.h. wird nicht untersttzt. }
                { Dabei dann immer signalisieren "schon fertig" }
           WriteByte := 0;
      GetPaletteData := 0;
          End;

   End;
  End;
End;

Function PutPaletteData( ProcessData : pVideoProcess; DataBuffer : pByte) : Word;
Const
   ATTR_CONTROL = $3C0;                         { Port fr Schreibzugriffe auf den Attribute Controller }
Var
  Lauf1,Lauf2 : Word;

Begin
 With ProcessData^ do
  Begin
   Case VioMode of                     { Nach Farben aufteilen !}
    $03,$02,$12,$10,$0D,$0E : Begin { 16 Farben (Ich mach immer 16 Bytes ! }
              For Lauf1 := 0 to 15 do
               Begin
                WriteAttributeReg(Lauf1,DataBuffer^);
                Inc(DataBuffer);
               End;
              Transmitted := 16;
              PutPaletteData := 0;
             End;
       $13 : Begin { 256 Farben }
              If ReturnBytes < 3 then PutPaletteData := 0;
              While ReturnBytes mod 3 <> 0 do Dec(ReturnBytes); { Es mssen immer komplette DAC-Register bertragen werden ! }
              Lauf1 := (Transmitted div 3);
              If (Transmitted + ReturnBytes) > Palette_Transmit[VioMode] then
               Begin
                PutPaletteData := 0;
                       Lauf2 := (Palette_Transmit[VioMode] - Transmitted) div 3;
               End
              Else
               Begin
                Lauf2 := ReturnBytes div 3;
         PutPaletteData := ReturnBytes;
               End;
              Asm
               Mov Ax, $1012
               Mov Bx, Lauf1
               Mov Cx, Lauf2
               Les Dx, DataBuffer
               Int $10
              End;
              Inc(Transmitted, ReturnBytes);
             End;
       else
        Begin
         PutPaletteData := 0;
        End;
   End;
  End;
End;
